Pre
------------------
Appplication requires gtest to be included as static library
as well as the gtest headers to be available.

I downloaded source and compiled by myself while having the libgtest-dev
package installed for headers.

g++ -c \
-I"/path/to/gtest-1.7.0/include" \
-I"/path/to/gtest-1.7.0/" \
src/gtest-all.cc \
-pthread \
-o libgtest.a 


Compilation
-----------

$ g++ main.cpp tests/*.cpp ga/*.cpp

Sequential program (strip parallel part before compilation):  
g++  -I"/path/to/project/includes" -L"/path/to/project" \
     -O0 -g3 -Wall main.cpp ga/*.cpp tests/*.cpp \
     -lgtest -pthread \
     -o application


All tests included:  
mpic++  -I"/path/to/project/includes" \
     -L"/path/to/project" -O0 -g3 -Wall \
     main.cpp ga/*.cpp tests/*.cpp tests-parallel/*.cpp \
     -lgtest -pthread -lmpich -lmpichcxx \
     -o application 
  
  
Parallel tests included:     
mpic++  -I"/path/to/project/includes" \
     -L"/path/to/project" -O0 -g3 -Wall \
     main.cpp ga/*.cpp tests-parallel/*.cpp \
     -lgtest -pthread -lmpich -lmpichcxx \
     -o application

Run Application
---------------
Note that the test are not run by default and the application can be fed with arguments.
Look into the main.cpp for the arguments taken into consideration.


Eclipse Setup
-------------
Install eclipse c/c++ and PTP extensions.
Note that per default "mpi.h" includes the default c based MPI header file whereas
the mpich2 headers are required. See
`http://jaqoup.wordpress.com/2009/05/10/configure-mpi-programs-in-eclipse/`
for the setup of mpich2 under eclipse (including sample run configuration). 

Parallel debugging
------------------
Install GDB.  

Compile, e.g. by 
`mpic++ main.cpp ga/*.cpp tests-parallel/*.cpp -O0`  
Set Flag `-O0` to avoid optimizations so that you do not run into the 
issue that a variable is not readable due to optimizations.

Run Debugger, e.g. by  
`mpirun -np 2 xterm -e gdb ./a.out`

You may use DDD as GDB GUI, but I did not get it running yet:
`mpirun -np 2 xterm -e ddd -gdb ./a.out`
