#include <sstream>
#include "FitnessResolver.h"
#include "CandidateSolution.h"

unsigned int CandidateSolution::instanceCounter = 0;

CandidateSolution::CandidateSolution() {
	this->id = CandidateSolution::instanceCounter++;
	this->birthIteration = -1;
	this->deathIteration = -1;
	this->fitness = -1;
}
CandidateSolution::CandidateSolution(int birthIteration, Maze maze, double fitness) {
	this->id = CandidateSolution::instanceCounter++;
	this->birthIteration = birthIteration;
	this->deathIteration = -1;
	this->maze = maze;
	this->fitness = fitness;
}

CandidateSolution::~CandidateSolution() {
	// TODO Auto-generated destructor stub
}

unsigned int CandidateSolution::getId() {
	return id;
}

Maze CandidateSolution::getMaze() {
	return maze;
}

Maze& CandidateSolution::getMazeReference() {
	return maze;
}

double CandidateSolution::getFitness() const {
	return fitness;
}

void CandidateSolution::kill(int iteration) {
	deathIteration = iteration;
}

std::string CandidateSolution::toString() {
	std::string result;
	std::ostringstream convert;
	convert << id;
	result += convert.str();
	convert.str("");
	result += ",";
	convert << fitness;
	result += convert.str();
	convert.str("");
	result += ",";
	result += maze.toString();
	return result;
}

bool CandidateSolution::operator == (const CandidateSolution& other) const {
	return maze == other.maze;
}

bool CandidateSolution::operator != (const CandidateSolution& other) const {
	return !(*this == other);
}

bool CandidateSolution::operator < (const CandidateSolution& other) const {
	double fitness = getFitness();
	double otherFitness = other.getFitness();
	if (fitness == otherFitness) {
		return maze < other.maze;
	}
	return fitness < otherFitness;
}
