#ifndef CANDIDATESOLUTION_H_
#define CANDIDATESOLUTION_H_

#include <set>
#include "Maze.h"

class CandidateSolution {
public:
	unsigned int getId();
	CandidateSolution();
	CandidateSolution(int birthIteration, Maze maze, double fitness);
	virtual ~CandidateSolution();
	void kill(int iteration);
	void addChild(CandidateSolution& child);
	double getFitness() const;
	Maze getMaze();
	Maze& getMazeReference();

	std::string toString();
	bool operator == (const CandidateSolution& other) const;
	bool operator != (const CandidateSolution& other) const;
	bool operator < (const CandidateSolution& other) const;
private:
	static unsigned int instanceCounter;
	unsigned int id;
	int birthIteration;
	int deathIteration;
	double fitness;
	Maze maze;
	double calculateFitness(Maze& maze);
};

#endif /* CANDIDATESOLUTION_H_ */
