/*
 * Edge.cpp
 *
 *  Created on: Jul 22, 2014
 *      Author: s10z
 */

#include "Vertex.h"
#include "Edge.h"

Edge::Edge( Vertex &source,  Vertex &destination) {
	this->source = source;
	this->destination = destination;
}

Vertex Edge::getSource() const {
	return source;
}

Vertex Edge::getDestination() const{
	return destination;
}

bool Edge::operator <(const Edge& other) const {
	Vertex source = getSource();
	Vertex destination = getDestination();
	Vertex otherSource = other.getSource();
	Vertex otherDestination = other.getDestination();

	if (source != otherSource ) {
		return source < otherSource;
	}
	if (destination != otherDestination) {
		return destination < otherDestination;
	}
	return false;
}

bool Edge::operator ==(const Edge&other) const {
	bool sameSource = getSource() == other.getSource();
	bool sameDestination = getDestination() == other.getDestination();
	return sameSource && sameDestination;
}

bool Edge::operator !=(const Edge& other) const {
	return !(*this == other);
}
