#include "FitnessResolver.h"
#include "BellmannFord.h"
#include "MazeToGraphConverter.h"
#include "CandidateSolution.h"

double FitnessResolver::getFitness(Maze maze) {
	MazeToGraphConverter converter;
	converter.createGraph(maze);
	Graph graph = converter.getGraph();
	BellmannFord bf = BellmannFord(graph);
	bf.calculateShortestPath(converter.getEntranceVertices(), converter.getExitVertices());
	//bf.logData();
	double fitness = bf.getShortestPathLength();
	if (fitness == BellmannFord::NO_PATH) {
		fitness = 0;
	}
	return fitness;
}
