#ifndef GENETICALGORITHM_H_
#define GENETICALGORITHM_H_

#include <set>
#include "CandidateSolution.h"
#include "Logger.h"

class GeneticAlgorithm {
public:
	GeneticAlgorithm(int populationSize, int mazeSize,
			int iterationCount, int maxParentsPerIteration, int maxMutationsPerIteration,
			int chanceOfMutation);
	int main();
protected:
	unsigned int populationSize;
	unsigned int mazeSize;
    unsigned int chanceOfMutation; // of 100
    unsigned int maxParentCountPerIteration;
    unsigned int maxMutationCountPerSpring;
    unsigned int iterationCount;

    Logger logger;
	std::set<CandidateSolution> population;
	std::set<CandidateSolution> createInitialPopulation(int populationSize, int mazeSize);
	void initializeLog();
	void writeLog(std::string line);
};

#endif /* GENETICALGORITHM_H_ */
