/*
 * Graph.cpp
 *
 *  Created on: Jul 22, 2014
 *      Author: s10z
 */

#include "Graph.h"

Graph::Graph() {
	// TODO Auto-generated constructor stub
}

Graph::~Graph() {
	// TODO Auto-generated destructor stub
}

bool Graph::hasVertex(Vertex vertex) {
	return 1 == vertices.count(vertex);
}

void Graph::addVertex(Vertex vertex) {
	vertices.insert(vertex);
	adjacent.insert(std::pair<Vertex, std::set<Vertex> >(vertex, std::set<Vertex>()));
}

void Graph::removeVertex(Vertex vertex) {
	vertices.erase(vertex);
	adjacent.erase(adjacent.find(vertex));
}

std::set<Vertex> Graph::getVertices() {
	return vertices;
}

void Graph::setAdjacent(Vertex u, Vertex v) {
	std::set<Vertex> values;
	values = adjacent[u];
	values.insert(v);
	adjacent[u] = values;
	values = adjacent[v];
	values.insert(u);
	adjacent[v] = values;
}

void Graph:: removeAdjacent(Vertex u, Vertex v) {
	std::set<Vertex> values;
	values = adjacent[u];
	values.erase(v);
	values = adjacent[v];
	values.erase(u);
}

std::set<Vertex> Graph::getAdjacentVertices(Vertex vertex) {
	if (adjacent.find(vertex) != adjacent.end()) {
		return adjacent[vertex];
	}
	return std::set<Vertex>();
}

void Graph::addEdge(Vertex u, Vertex v, int weight) {
	if (hasEdge(u,v)) {
		removeEdge(u,v);
	}
	if (weight > 0) {
		setAdjacent(u, v);
		edges.insert(std::pair<Edge, int>(Edge(u,v), weight));
		edges.insert(std::pair<Edge, int>(Edge(v,u), weight));
	}
}

void Graph::removeEdge(Vertex u, Vertex v) {
	removeAdjacent(u, v);
	std::map<Edge,int>::iterator it;
	if (hasEdge(u,v)) {
		it = edges.find(Edge(u,v));
		edges.erase(it);
	}
	if (hasEdge(v,u)) {
		it = edges.find(Edge(v,u));
		edges.erase(it);
	}
}

bool Graph::hasEdge(Vertex u, Vertex v) {
	return 0 < edges.count(Edge(u,v));
}

int Graph::getEdgeWeight(Vertex u, Vertex v) {
	int result = 0;
	if (hasEdge(u,v)) {
		result = edges.at(Edge(u,v));
	}
	return result;
}

int Graph::getEdgeCount() const {
	return edges.size() /2; // mimic undirected graph
}

int Graph::getVertexCount() const {
	return vertices.size();
}

