#include "MazeToGraphConverter.h"
#include "Maze.h"

MazeToGraphConverter::MazeToGraphConverter() {

}

MazeToGraphConverter::~MazeToGraphConverter() {
	// TODO Auto-generated destructor stub
}

Graph MazeToGraphConverter::getGraph() {
	return graph;
}

std::set<Vertex> MazeToGraphConverter::getEntranceVertices() {
	std::set<Vertex> entrances = std::set<Vertex>();
	Vertex v;
	for (int i = 0; i < maze.getWidth(); i += 1) {
		if (hasVertexRepresentation(i)) {
			v = getVertexForField(i);
			entrances.insert(v);
		}
	}
	return entrances;
}

std::set<Vertex> MazeToGraphConverter::getExitVertices() {
	std::set<Vertex> exits = std::set<Vertex>();
	Vertex v;
	for (int i = maze.getFieldCount() - maze.getWidth(); i < maze.getFieldCount(); i += 1) {
		if (hasVertexRepresentation(i)) {
			v = getVertexForField(i);
			exits.insert(v);
		}
	}
	return exits;
}

bool MazeToGraphConverter::hasVertexRepresentation(int fieldNo) {
	Vertex v = getVertexForField(fieldNo);
	return graph.hasVertex(v);
}

Vertex MazeToGraphConverter::getVertexForField(int fieldNo) {
	return Vertex(fieldNo);
}

// TODO: The current implementation discards any possibility
// 			to move non-orthogonal through the maze. Add this.
void MazeToGraphConverter::createGraph(Maze maze) {
	Graph g = Graph();
	Vertex u;
	Vertex v;
	int width = maze.getWidth();
	int fieldCount = maze.getFieldCount();
	for(int i = 0; i < fieldCount; i += 1) {
		bool fieldValue = maze.getFieldValue(i);
		if (fieldValue) {
			continue;
		}
		u = getVertexForField(i);
		g.addVertex(u);

		int nextTop = i - width;
		int nextLeft = i - 1;

		v = getVertexForField(nextTop);
		if (nextTop >= 0 && g.hasVertex(v)) {
			g.addEdge(u, v, ORTHOGONAL_DISTANCE);
		}

		v = getVertexForField(nextLeft);
		if (i % width > 0 && g.hasVertex(v)) {
			g.addEdge(u,v, ORTHOGONAL_DISTANCE);
		}
	}

	this->graph = g;
	this->maze = maze;
}
