#include "Graph.h"
#include "Maze.h"

#ifndef MazeTOGRAPHCONVERTER_H_
#define MazeTOGRAPHCONVERTER_H_

class MazeToGraphConverter {
public:
	static const int ORTHOGONAL_DISTANCE = 1;
	MazeToGraphConverter();
	virtual ~MazeToGraphConverter();
	void createGraph(Maze maze);
	Graph getGraph();
	std::set<Vertex> getEntranceVertices();
	std::set<Vertex> getExitVertices();
	virtual bool hasVertexRepresentation(int fieldNo);
	virtual Vertex getVertexForField(int fieldNo);
protected:
	Maze maze;
	Graph graph;
};

#endif /* MazeTOGRAPHCONVERTER_H_ */
