#include "ParallelFitnessResolver.h"
#include "ParallelBellmannFord.h"
#include "ParallelMazeToGraphConverter.h"

double ParallelFitnessResolver::getFitness(Maze maze) {
	ParallelMazeToGraphConverter converter;
	converter.createGraph(maze);
	Graph graph = converter.getGraph();
	ParallelBellmannFord bf = ParallelBellmannFord(graph);
	bf.calculateShortestPath(converter.getEntranceVertices(), converter.getExitVertices());
	//bf.logData();
	double fitness = bf.getShortestPathLength();
	if (fitness == BellmannFord::NO_PATH) {
		fitness = 0;
	}
	return fitness;
}
