#ifndef PARALLELMAZETOGRAPHCONVERTER_H_
#define PARALLELMAZETOGRAPHCONVERTER_H_

#include "MazeToGraphConverter.h"

class ParallelMazeToGraphConverter : public MazeToGraphConverter {
public:
	ParallelMazeToGraphConverter();
	Vertex getVertexForField(int fieldNo);
	void createGraph(Maze m);
private:
	/**
	 * The neighbors exit vertices are adjacent
	 * to the own entrance vertices, located in the
	 * row above.
	 */
	std::deque<Vertex> ghostExitVertices;
	/**
	 * The neighbors entrance vertices are adjacent
	 * to the own exit vertices, located in the
	 * row below.
	 */
	std::deque<Vertex> ghostEntranceVertices;

	void communicateGhostVertices();
	void sendEntranceVertices(int destination);
	void receiveEntranceVertices(int source);
	void sendExitVertices(int destination);
	void receiveExitVertices(int source);
	void createMessage(std::set<Vertex> source, int* destination);

	void connectEntrancesToGhosts(Graph& graph);
	void connectExitsToGhosts(Graph& graph);
};

#endif /* PARALLELMAZETOGRAPHCONVERTER_H_ */
