#include <stdlib.h>
#include "SpringResolver.h"

std::pair<Maze, Maze> SpringResolver::createSpring(
		std::pair<Maze, Maze> parents) {
	Maze parent_1 = parents.first;
	Maze parent_2 = parents.second;
	Maze child_1 = Maze(parent_1.getWidth(), parent_1.getHeight());
	Maze child_2 = Maze(parent_1.getWidth(), parent_1.getHeight());
	unsigned int breakpoint = rand() % parent_1.getFieldCount();
	unsigned int fieldCount = parent_1.getFieldCount();
	bool fieldValue;

	for (unsigned int i = 0; i < breakpoint; i += 1) {
		fieldValue = parent_1.getFieldValue(i);
		child_1.setFieldValue(i, fieldValue);
	}
	for (unsigned int i = breakpoint; i < fieldCount; i += 1) {
		fieldValue = parent_2.getFieldValue(i);
		child_1.setFieldValue(i, fieldValue);
	}
	for (unsigned int i = 0; i < breakpoint; i += 1) {
		fieldValue = parent_2.getFieldValue(i);
		child_2.setFieldValue(i, fieldValue);
	}
	for (unsigned int i = breakpoint; i < fieldCount; i += 1) {
		fieldValue = parent_1.getFieldValue(i);
		child_2.setFieldValue(i, fieldValue);
	}

	return std::pair<Maze, Maze>(child_1, child_2);
}
