#include "ZigZagMaze.h"
#include "mpi.h"
#include "../ga/ParallelMaze.h"

// Layout (rank 1 part stretched if size > 3):
//_      _
// oxxxxx
//_oxooox_ rank 0
// oxoxox
//_oxoxox_ rank 1
// oooxoo
//_xxxxox_ rank 2
//
Maze createZigZagMaze() {
	int size = MPI::COMM_WORLD.Get_size();
	int rank = MPI::COMM_WORLD.Get_rank();

	int mazeWidth = 6;
	int mazeHeight = 2;
	Maze m = ParallelMaze(mazeWidth, mazeHeight * size);
	bool value;
	for (int i = 0, max = m.getFieldCount(); i < max; i += 1) {
		int ofRow = i % mazeWidth;
		if (rank == 0) {
			value = (i < mazeWidth && i != 0) || (ofRow % 4 == 1);
		} else if (rank == size - 1) {
		    value = (i >= mazeWidth && ofRow != mazeWidth - 2) || (ofRow % 4 == 3);
		} else {
			value = (ofRow % 2 == 1);
		}
		m.setFieldValue(i, value);
	}
	return m;
}
