#include "../ga/FitnessResolver.h"
#include "../ga/Maze.h"
#include <math.h>
#include "gtest/gtest.h"
#include "createSampleMaze.h"

TEST(FitnessResolver, fitnessWhenNoPathExists) {
	std::vector<int> values = std::vector<int>();
	values.push_back(0);
	values.push_back(0);
	values.push_back(0);
	values.push_back(1);
	values.push_back(1);
	values.push_back(1);
	Maze maze = createSampleMaze(3, values);
	double fitness = FitnessResolver::getFitness(maze);

	// "Fitness is expected to be zero when here is no path through maze"
	EXPECT_EQ(0, floor(fitness + 0.5));
}

TEST(FitnessResolver, fitnessWithSimplePath) {
	std::vector<int> values = std::vector<int>();
	values.push_back(1);
	values.push_back(0);
	values.push_back(1);
	values.push_back(1);
	values.push_back(0);
	values.push_back(1);
	values.push_back(1);
	values.push_back(0);
	values.push_back(1);
	Maze maze = createSampleMaze(3, values);
	double fitness = FitnessResolver::getFitness(maze);

	// "Fitness is expected to be three running straight through 3x3 maze"
	EXPECT_EQ(2, floor(fitness + 0.5));
}
