function MazeRenderer(svgContainer, maze, mazeSize, renderFieldSize) {
    var vis = svgContainer.append("svg:svg")
    .attr("width", mazeSize * renderFieldSize)
    .attr("height", mazeSize * renderFieldSize)
    .attr("class", "maze")
    
    vis.selectAll("rect")
       .data(maze)
       .enter()
            .append("rect")
       .attr("class", function(d) { 
           return "maze-field maze-field-" + (d == 0 ? "path" : "wall" )  
       })
       .attr("x", function(d, i) {
           var rel = i % mazeSize;
           return rel * renderFieldSize;
       })
       .attr("y", function(d, i) {
           var rel = Math.floor(i / mazeSize);
           return rel * renderFieldSize;
       })
       .attr("width", renderFieldSize)
       .attr("height", renderFieldSize);
}