function PopulationView(populationContainer, mazeSize, renderFieldSize, eventDuration) {
    var that = {},
        population = [];
    
    function sortByFitness (a, b){
        var aF = a.getFitness(),
            bF = b.getFitness();
        if (aF < bF) {
            return -1;
        }
        if (bF < aF) {
            return 1;
        }
        return 0;
    }
    
    function addCandidate(candidate) {
        var id = candidate.getId();
        var fitness = candidate.getFitness();
        population.push(candidate);
        population.sort(sortByFitness);
    }
    
    function removeCandidate(candidate) {
        // (same but not identical objects)
        for (var i = 0; i < population.length; i += 1) {
            if (population[i].getId() == candidate.getId()) {
                break;
            }
        }
        var population_1 = population.slice(0, i);  
        var population_2 = [];
        if (i < population.length - 1) {
            population_2 = population.slice(i + 1, population.length);
        } 
        population = population_1.concat(population_2);
    }
    
    function populationToFitness(element) {
        return +element.getFitness();
    }
    
    function getFitness() {
        return population.map(populationToFitness);
    }
    
    that.addCandidate = addCandidate;
    that.removeCandidate = removeCandidate;
    that.getFitness = getFitness;
    return that;
}