/**
 * Taken from http://bl.ocks.org/mbostock/4061502
 * and customized.
 */
function renderBox(container, data, min, max, w, h) {
    var margin = {top: 10, right: 20, bottom: 10, left: 20},
        width = w - margin.left - margin.right,
        height = h - margin.top - margin.bottom;
    
    var chart = d3.box()
        .whiskers(iqr(1.5))
        .width(width)
        .height(height)
        .domain([min, max]);
    
    container.selectAll("svg")
          .data([data])
        .enter().append("svg")
          .attr("class", "box")
          .attr("width", width + margin.left + margin.right)
          .attr("height", height + margin.bottom + margin.top)
        .append("g")
          .attr("transform", "translate(" + margin.left + "," + margin.top + ")")
          .call(chart);
}

function randomize(d) {
  if (!d.randomizer) d.randomizer = randomizer(d);
  return d.map(d.randomizer);
}

function randomizer(d) {
  var k = d3.max(d) * .02;
  return function(d) {
    return Math.max(min, Math.min(max, d + k * (Math.random() - .5)));
  };
}

// Returns a function to compute the interquartile range.
function iqr(k) {
  return function(d, i) {
    var q1 = d.quartiles[0],
        q3 = d.quartiles[2],
        iqr = (q3 - q1) * k,
        i = -1,
        j = d.length;
    while (d[++i] < q1 - iqr);
    while (d[--j] > q3 + iqr);
    return [i, j];
  };
}